#!/bin/sh

###############################################################################
# Author: Suite 3220 Software (www.suite3220.com)
#
# E-Mail: moonshine@suite3220.com
#
# Licence: QPL 1.0
#
# Description:
#
#   Script provided to convert a module in moonshine 0.9.7 - 1.0.x module 
#   format to moonshine verion 1.1 module format.
#
###############################################################################

for module in $*
do
id=$(head -n 1 $module)
if [ "$id" = "#Moonshine Module File" ]
then 
  echo $module is elready in 0.9.7 format
  exit 0
fi
if [ "$id" = "#Moonshine Project Module" ]
then
#  mv $module $module.0.9.7
#  cat $module.0.9.7 | awk -F ',' '\
  cat $module | awk -F ',' '\
    /#Moonshine Project Module/ {\
      $0="#Moonshine Module File"; \
    } \
    / *, *none *, */ { \
      $0=sprintf("%s, <none>, %s, %s", $1, $3, $4); \
    } \
    / *, *builtin *, */ { \
      sub("open with", "openwith; %openwith", $4);\
      sub("print", "print; %print", $4);\
      $0=sprintf("%s, %s, $%s", $1, $2, substr($4, match($4, "[^  \t]"))); \
    } \
    / *, *captured *, */ { \
      $0=sprintf("%s, %s, @%s", $1, $2, substr($4, match($4, "[^  \t]"))); \
      gsub("; ","; @"); \
      gsub("cd ","$cd ");
      gsub("[@][$]","@");
    } \
    / *, *system *, */ { \
      $0=sprintf("%s, %s, %s", $1, $2, substr($4, match($4, "[^  \t]"))); \
      gsub("cd ","$cd ");
    } \
    / *, *help *, */ { \
      $0=sprintf("%s, %s, (%s)", $1, $2, substr($4, match($4, "[^  \t]"))); \
    }\
    / *, *menu *, */ { \
      if (match($4,"[:graph:]") > 0) \
        $0=sprintf("%s, %s, <%s>", $1, $2, substr($4, match($4, "[^  \t]"))); \
      else \
        $0=sprintf("%s, %s, <%s>", $1, $2, $1); \
    } \
    / *, *menu$/ { \
      $0=sprintf("%s, %s, <%s>", $1, $2, $1); \
    } \
    { \
    print $0; \
    } ' # > $module
fi
done

